# Generated by Django 5.2 on 2025-04-16 08:53

import django.db.models.deletion
from django.db import migrations, models

from ..models import TagField


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='DataKey',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('path', models.CharField(max_length=200)),
                ('digest', models.CharField(max_length=40)),
                ('creation', models.DateTimeField(blank=True, null=True)),
                ('metadata', models.TextField(blank=True)),
            ],
            options={
                'ordering': ('path',),
            },
        ),
        migrations.CreateModel(
            name='Datastore',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', models.CharField(max_length=100)),
                ('parameters', models.CharField(max_length=200)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Dependency',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(max_length=50)),
                ('path', models.CharField(max_length=200)),
                ('version', models.CharField(max_length=40)),
                ('diff', models.TextField(blank=True)),
                ('source', models.CharField(blank=True, max_length=200, null=True)),
                ('module', models.CharField(max_length=50)),
            ],
            options={
                'ordering': ['name'],
            },
        ),
        migrations.CreateModel(
            name='Executable',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('path', models.CharField(max_length=200)),
                ('name', models.CharField(max_length=50)),
                ('version', models.CharField(max_length=100)),
                ('options', models.CharField(max_length=50)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='LaunchMode',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', models.CharField(max_length=100)),
                ('parameters', models.CharField(max_length=1000)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='ParameterSet',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', models.CharField(max_length=100)),
                ('content', models.TextField()),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='PlatformInformation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('architecture_bits', models.CharField(max_length=100)),
                ('architecture_linkage', models.CharField(max_length=100)),
                ('machine', models.CharField(max_length=20)),
                ('network_name', models.CharField(max_length=100)),
                ('ip_addr', models.GenericIPAddressField()),
                ('processor', models.CharField(max_length=100)),
                ('release', models.CharField(max_length=100)),
                ('system_name', models.CharField(max_length=20)),
                ('version', models.CharField(max_length=200)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Project',
            fields=[
                ('id', models.SlugField(primary_key=True, serialize=False)),
                ('name', models.CharField(max_length=200)),
                ('description', models.TextField(blank=True)),
            ],
            options={
                'ordering': ('id',),
            },
        ),
        migrations.CreateModel(
            name='Repository',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('type', models.CharField(max_length=100)),
                ('url', models.URLField()),
                ('upstream', models.URLField(blank=True, null=True)),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Record',
            fields=[
                ('label', models.CharField(max_length=100)),
                ('db_id', models.AutoField(primary_key=True, serialize=False)),
                ('reason', models.TextField(blank=True)),
                ('duration', models.FloatField(null=True)),
                ('main_file', models.CharField(max_length=100)),
                ('version', models.CharField(max_length=50)),
                ('outcome', models.TextField(blank=True)),
                ('timestamp', models.DateTimeField()),
                ('tags', TagField(blank=True, max_length=255)),
                ('diff', models.TextField(blank=True)),
                ('user', models.CharField(max_length=100)),
                ('script_arguments', models.TextField(blank=True)),
                ('stdout_stderr', models.TextField(blank=True)),
                ('repeats', models.CharField(blank=True, max_length=100, null=True)),
                ('datastore', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='django_store.datastore')),
                ('dependencies', models.ManyToManyField(to='django_store.dependency')),
                ('executable', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to='django_store.executable')),
                ('input_data', models.ManyToManyField(related_name='input_to_records', to='django_store.datakey')),
                ('input_datastore', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, related_name='input_to_records', to='django_store.datastore')),
                ('launch_mode', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='django_store.launchmode')),
                ('parameters', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='django_store.parameterset')),
                ('platforms', models.ManyToManyField(to='django_store.platforminformation')),
                ('project', models.ForeignKey(null=True, on_delete=django.db.models.deletion.PROTECT, to='django_store.project')),
                ('repository', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to='django_store.repository')),
            ],
            options={
                'ordering': ('-timestamp',),
            },
        ),
        migrations.AddField(
            model_name='datakey',
            name='output_from_record',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='output_data', to='django_store.record'),
        ),
    ]
